#!/usr/bin/perl
# 
# ezguest.pl - EZ Guestbook Generator - by Manny Juan <manny@jps.net> 1/23/99
# http://www.mannyjuan.com/userpages/
#
# v1.40 9/15/2001 - added capability to accept user logo and/or user background
# v1.30 3/1/2000 - added capability to delete guestbook entries
#          the idea was suggested by andrew burke <andrew@cobra.net>
# this program was adapted from ezhomepg.pl
#
# This will give your visitors the opportunity to set up a guestbook on your site.
# the generated guestbook uses ezguesta.pl, patterned after matt wright's guestbook 
# script, and modified so it could service multiple guestbooks and support automatic 
# expiration of entries by age or file size.
#####################################################################################
$SIG{__DIE__} = \&Error_Msg;

sub Error_Msg {
    $msg = "@_";
    print "\ncontent-type: text/html\n\n";
    print "The following error occurred : $msg\n";
    exit;
}

# Get the input
read(STDIN, $input, $ENV{'CONTENT_LENGTH'});

    # split the input
    @pairs = split(/&/, $input);

    # split the name/value pairs
    foreach $pair (@pairs) {

    ($name, $value) = split(/=/, $pair);

    $name =~ tr/+/ /;
    $name =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
    $value =~ tr/+/ /;
    $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
    $value =~ s/<([^>]|\n)*>//g;

    $FORM{$name} = $value;
    }
$userdir = $FORM{'userdir'};

######################################################################################
# set variables HERE

$win95=0;
$cgi='pl';
# Set this to your base HTML directory. This is a PATH not a URL
# $base_dir = "../webpages/$userdir";
$base_dir = "/home/manny/www/$userdir";

# $cgiurl = "/cgi-bin";
$cgiurl = "/cgi-bin";

# This is your URL of where the new HTML pages will be kept - keep the trailing slash
# $baseurl = "/$userdir/";
$baseurl = "http://mannyjuan.com/$userdir/";

# This is a URL and dir for the images sub directory in the userpages directory.
# Create the images directory in the userpages directory. This is where
# you will upload your background images
# $imageurl = "/$userdir";
$imageurl = "http://mannyjuan.com/$userdir/";

# This is the path for user pages. You don't really need to change this
# Just make sure to create a directory: userpages and chmod it 777
$page_dir = "$base_dir/";

# This is the index of all generated pages
# This file should be chmod to 777 and placed in the userpages directory
$indexpage = "$base_dir/index.html";

# This is the location of the banana.txt file. This holds each user's
# login name and e-mail address for confirmation
$data = "$base_dir/data.txt";

#Site title

$title="EZ Guestbook Mall";

# self explanatory variables for your site logo
$logo = "$imageurl/mjmall.jpg";
$logoalt = "Cyber Mall";

# Location of the sendmail program
$sendmail = '/usr/sbin/sendmail';

# Your e-mail address here
$myemail = 'manny@jps.net';

# That's it.

# DO NOT CHANGE ANYTHING BELOW THIS LINE
######################################################################################

# Lets do some translating first
$usrname = $FORM{'usrname'};
$login = $FORM{'login'};
$email = $FORM{'email'};
$pagename = $FORM{'pagename'};
$headline = $FORM{'headline'};
$content = $FORM{'content'};
$updact = $FORM{'updact'};
$colorset = $FORM{'colorset'};
$maxdays = $FORM{'maxdays'};
$maxitems = $FORM{'maxitems'};
$recipient = $FORM{'email'};
$separator = $FORM{'separator'};
$mail = $FORM{'mail'};
$linkmail = $FORM{'linkmail'};
$remote_mail = $FORM{'remote_mail'};
$line_breaks = $FORM{'line_breaks'};
$retlink = $FORM{'retlink'};

$usemybkgd=$FORM{'usemybkgd'};
$mybkgdurl=$FORM{'mybkgdurl'};
$usemylogo=$FORM{'usemylogo'};
$mylogourl=$FORM{'mylogourl'};

$gbparms="$maxdays~$maxitems~$recipient~$separator~$mail~$linkmail~$remote_mail~$line_breaks~$retlink~$usemybkgd~$mybkgdurl~$usemylogo~$mylogourl";

# Add the line breaks for paragraph spacing
#$content =~ s/&&/<br><br>/g;
$content =~ s/&&/%%/g;

# This fixes the bug of white space and
# other wierd spacing:
$content =~ s/\cM//g;
$content =~ s/\n/  /g;

# If the user tries to add more than one word in
# the page name field, this will put an underscore
# in the spaces to make it one word
$pagename =~ s/ /_/g;

if ($FORM{'action'} eq "New Page") {
    &newpage;
    }
if ($FORM{'action'} eq "Create Page") {
    &create;
    }
if ($FORM{'action'} eq "Edit Page") {
    &confirm("edit");
    }
if ($FORM{'action'} eq "checkuser") {
    &checkuser;
    }
if ($FORM{'action'} eq "recreate") {
    &recreate;
    }
if ($FORM{'action'} eq "Delete Page") {
    &confirm("delete");
    }
    exit;
sub newpage {
    local($usrname, $email, $headline, $content, $pagename, $colorset, $gbparms);

    ($usrname, $email, $headline, $content, $pagename, $colorset, $gbparms) = split(/&&/, "");

    # To avoid any security risks. Take out the HTML tags added when HPM translated
    # the && to: <br><br>. They will be re-translated to: && Once the user updates
    # the page, the: && will be put back to: <br><br>
    $content =~ s/<br><br>/&&/g;

    $retlink="http://";
    $mybkgdurl="http://";
    $mylogourl="http://";

    # print the edit-page form

    print "content-type: text/html\n\n";
    print "<html><head><title>Create Your Own Guestbook</title></head>\n";
    print "<body bgcolor=\"#ffffff\" TEXT=\"#000000\" link=\"#008000\" vlink=\"#800040\">\n";
    &put_banner;
    print "<center><img src=\"$logo\" alt=\"$logoalt\" border=0></center><p>\n";
    print "<table width=75% cellspacing=2 cellpadding=2 border=0>\n";
    print "<tr><td width=100% align=left valign=top>\n";
    print "<p><font face=\"Arial, Geneva\"><h2>Create Your Own Guestbook</h2></font></p>\n";
    print "<p>Below is an empty form for you to fill in. The next five fields (<b>bold</b>) are required.\n";
    print "You can edit any part of your page later</p>\n";
    print "<p></p>\n";
    print "<form action=\"$cgiurl/ezguest.$cgi\" method=POST>\n";
    print "<input type=hidden name=\"userdir\" value=\"$userdir\">\n";
    print "<input type=hidden name=\"action\" value=\"Create Page\">\n";
    print "<b>Your name:</b><br>\n";
    print "<font size=\"-1\">(will appear in page as link to your email)</font><br>\n";
    print "<input type=text size=40 name=\"usrname\" value=\"$usrname\"><br><br>\n";
    print "<h3>(The next 3 fields will be used for editing)<h3>\n";
    print "<b>Login Id:</b>\n";
    print "<font size=\"-1\">(one word only you should know, used later for editing)</font><br>\n";
    print "<input type=text size=40 name=\"login\" value=\"$login\"><br><br>\n";
    print "<b>Your e-mail:</b>\n";
    print "<font size=\"-1\">(used for editing, will also appear in page)</font><br>\n";
    print "<input type=text size=40 name=\"email\" value=\"$email\"><br><br>\n";
    print "<b>Your page:</b>\n";
    print "<font size=\"-1\">(one word, will become the name of your html file)</font><br>\n";
    print "<input type=text size=40 name=\"pagename\" value=\"$pagename\"><br><br>\n";
    print "<b>headline:</b>\n";
    print "<font size=\"-1\">(how your page will be listed in index)</font><br>\n";
    print "<input type=text size=40 name=\"headline\" value=\"$headline\"><br><br>\n";
    print "</td></tr></table>\n";
    &build_form_content($usrname, $email, $headline, $content, $pagename, $colorset, $gbparms);
    print "<P><input type=submit value=\"create page\">\n";
    print "</form>\n";
    print "</body></html>\n";
    }

sub create {

    # Now, lets do some error checking. Making sure they filled out each field
    # This is pretty low tech now. I'll improve it later
    &missing(missing_name) unless $usrname;
    &missing(missing_email) unless $email;
    &missing(missing_pagename) unless $pagename;

    # if they try to name their page "index" This will stop them
    if (uc($pagename) eq "INDEX") {
        print "content-type: text/html\n\n";
        print "<html><head><title>Error</title></head>\n";
        print "<body>";
        &put_banner;
        print "<center><img src=\"$logo\" alt=\"$logoalt\" border=0></center><p>\n";
        print "<p>You cannot name your page <b>index</b>\n";
        print "Please go back and re-name your page</p>\n";
        print "<p>(Return to <a href=\"$baseurl\">User Pages</a>)\n";
        exit;
        }
    # if they Don't give their page a headlineing This will stop them
    if ($headline eq "") {
        print "content-type: text/html\n\n";
        print "<html><head><title>Error</title></head>\n";
        print "<body>";
        &put_banner;
        print "<p>You MUST give your page a <b>headline</b>\n";
        print "Please go back and enter one for your page</p>\n";
        exit;
        }

    # if the user tries to name their page 
    # something that is already taken
    # this will HOPEFULLY stop them :)
    # This block was written by Norm
    if (-e "$page_dir$pagename\.html") {
        print "content-type: text/html\n\n";
        print "<html><head><title>Error</title></head>\n";
        print "<body>";
        &put_banner;
        print "<p>The page name: <b>$pagename</b>\n";
        print "is already taken.\n";
        print "Please go back and rename your page</p>\n";
        print "<p>(Return to <a href=\"$baseurl\">User Pages</a>)\n";
        exit;
        }

    &chk_bad_maxitems;
    &chk_bad_maxdays;

    #now, lets create our new html page
    &buildpage_top($colorset,$gbparms);
    &buildpage_bot;
    &save_page_data;

    # Write the login name and email address to a separate file for confirmation
    # when they want to edit their page
    open (FILE, ">>$data") || die "I can't open >>$data\n";
    if($win95==0){flock (FILE, 2) or die "can't lock data file\n";}
    print FILE "$login&&$email&&$pagename\n";
    close(FILE);


    # Suck the index page, and write the new entry to it
    open(FILE, "$indexpage") || die "I can't open that file $indexpage\n";
    if($win95==0){flock (FILE, 1) or die "can't lock index file\n";}
    @lines = <FILE>;
    close(FILE);
    $sizelines = @lines;

    # Now, re-open the links file, and add the new link
    open(FILE, ">$indexpage") || die "I can't open that file >$indexpage\n";
    if($win95==0){flock (FILE, 2) or die "can't lock index file\n";}

    for ($a = 0; $a <= $sizelines; $a++) {

        $_ = $lines[$a];

        if (/<!--begin-->/) {

            print FILE "<!--begin-->\n";
            print FILE "<p><font face=\"Arial, Geneva\" size=4><a href=\"$baseurl$pagename.html\">$headline</a></p>\n";

        } else {
            print FILE $_;
            }
        }
    close(FILE);


    # Give the user a response
    print "content-type: text/html\n\n";
    print "<html><head><title>thanks</title></head>\n";
    print "<body bgcolor=\"#ffffff\" TEXT=\"#000000\" link=\"#008000\" vlink=\"#800040\">\n";
    &put_banner;
    print "<center><img src=\"$logo\" alt=\"$logoalt\" border=0></center><p>\n";
    print "<BR><BR><FONT SIZE=4 FACE=\"COMIC SANS MS,ARIAL\">\n";

    print "Your page has been created, and you will receive an e-mail confirming this!\n";
    print "Your URL is: <a href=\"$baseurl$pagename\.html\">\n";
    print "$baseurl$pagename\.html</a>\n";
    print "Remember to press Reload.\n";
    print "Thanks for your participation!\n";
    print "<p>(Return to <a href=\"$baseurl\">User Pages</a>)\n";
    print "</body></html>\n";


    # Send the user an e-mail confirming their page
    open (MAIL, "| $sendmail -t") || die "I can't open sendmail\n";
    print MAIL "To: $usrname <$email>\n";
    print MAIL "From: $myemail\n";
    print MAIL "Subject: Your new URL on the $title\n";
    print MAIL "Your page can be viewed at the URL below:\n";
    print MAIL "\n";
    print MAIL "$baseurl$pagename\.html\n";
    print MAIL "\nThank you for using the $title\n";
    print MAIL "\n\nThe Mall Manager - $myemail\n";
    close (MAIL);

    # Notify us when someone creates a page
    open (MAIL, "| $sendmail -t") || die "I can't open sendmail\n";
    print MAIL "To: $myemail\n";
    print MAIL "From: $usrname <$email>\n";
    print MAIL "Subject: $title New Page Report\n";
    print MAIL "$usrname created a new page:\n";
    print MAIL "$baseurl$pagename\.html\n";
    print MAIL "\nThe content is :\n$content\n";
    close(MAIL);

    }

sub recreate {
    &chk_bad_maxitems;
    &chk_bad_maxdays;

    #now, lets create our new html page
    # Suck the guestbook page
    open(FILE, "$page_dir$pagename.html") || die "I can't open that file page_dir$pagename.html\n";
    if($win95==0){flock (FILE, 1) or die "can't lock data file\n";}
    @lines = <FILE>;
    close(FILE);
    $sizelines = @lines;

    &buildpage_top($colorset, $gbparms);

    # rewrite the older entries, start from marker until end
    $sw=0;
    for ($a = 0; $a <= $sizelines; $a++) {
        $_ = $lines[$a];
        if(/<!--begin-->/) {$sw=1;}
        if ($sw==1) {
            print HTML "$_"; 
            }
        }
    &save_page_data;

    &ntfy_usr_edt;

    # Give the user a response
    print "content-type: text/html\n\n";
    print "<html><head><title>thanks</title></head>\n";
    print "<body bgcolor=\"#ffffff\" TEXT=\"#000000\" link=\"#008000\" vlink=\"#800040\">\n";
    &put_banner;
    print "<CENTER><IMG SRC=\"$logo\" alt=\"$logoalt\" border=0></CENTER>\n";
    print "<P><BR><BR><FONT SIZE=4 FACE=\"COMIC SANS MS,ARIAL\">\n";
    print "Your page has been revised, and you will receive an e-mail confirming this!\n";
    print "Your URL is: <a href=\"$baseurl$pagename\.html\">\n";
    print "$baseurl$pagename\.html</a>\n";
    print "Remember to press Reload.\n";
    print "Thanks for your participation!\n";
    print "<p>(Return to <a href=\"$baseurl\">User Pages</a>)\n";
    print "</body></html>\n";
    }

sub ntfy_usr_edt {
    # Send the user a notice that their page has been re-done
    open (MAIL, "| $sendmail -t") || die "I can't open sendmail\n";
    print MAIL "To: $usrname <$email>\n";
    print MAIL "From: $myemail\n";
    print MAIL "Subject: Your Changes on the $title\n";
    print MAIL "Your revised page can be viewed at the URL below:\n";
    print MAIL "\n";
    print MAIL "$baseurl$pagename\.html\n";
    print MAIL "\nOnce again thank you for using the $title\n";
    print MAIL "\n\nThe Mall Manager\n";
    close (MAIL);
    }

sub chk_bad_maxitems {
    if ($maxitems !~ /^(\d){1,3}$/) {
        print "content-type: text/html\n\n";
        print "<html><head><title>Error</title></head>\n";
        print "<body>";
        &put_banner;
        print "<center><img src=\"$logo\" alt=\"$logoalt\" border=0></center><p>\n";
        print "<p>invalid or unreasonable value for maxitems.\n";
        print "<p>Please go back and correct</p>\n";
        exit;
        }
    }
sub chk_bad_maxdays {
    if ($maxdays !~ /^(\d){1,3}$/) {
        print "content-type: text/html\n\n";
        print "<html><head><title>Error</title></head>\n";
        print "<body>";
        &put_banner;
        print "<center><img src=\"$logo\" alt=\"$logoalt\" border=0></center><p>\n";
        print "<p>invalid or unreasonable value for maxdays.\n";
        print "<p>Please go back and correct</p>\n";
        exit;
        }
    }
sub buildpage_top {
    local ($colorset, $gbparms) = @_;
    if ($colorset eq "") {$colorset='FFFFFF~333333~006699~999900';}
    ($bkgdc, $textc, $linkc, $vlinkc) = split('~', $colorset);
    open(HTML, ">$page_dir$pagename\.html") || die "I can't create that file >$page_dir$pagename\.html\n";
    if($win95==0){flock (HTML, 2) or die "can't lock html file\n";}

    print HTML "<html><head><title>guestbook by ezguest.$cgi</title></head>\n";
    print HTML "<body ";
    if ($usemybkgd==1) {
        print HTML "background=\"$mybkgdurl\"&nbsp";
        }
    print HTML "bgcolor=\"#$bkgdc\" TEXT=\"#$textc\" link=\"#$linkc\" vlink=\"#$vlinkc\">\n";
#   print HTML "\n<!--banner code here-->";
    print HTML "<center><img src=\"";
    if ($usemylogo==1) {
        print HTML "$mylogourl";
        }
    else {
        print HTML "$logo";
        }
    print HTML "\" alt=\"$logoalt\" border=0></center><p>\n";

    print HTML "<center><h1>$headline</h1><h3>guestbook</h3></center>\n";
    print HTML "<A HREF=\"$retlink\">Return</A>\n";
    print HTML "<br><A HREF=\"$baseurl\">Visit EZ Guestbook Mall</A>\n";
    print HTML "<form method=POST action=\"$cgiurl/ezguesta.$cgi\">";
    print HTML "<p>Thank you for visiting our pages.  We would love it if you would ";
    print HTML "add your comments and suggestions to this guestbook we are keeping!";
    print HTML "<p><input type=submit value='Add Comment'>\n";
    print HTML "<input type=hidden name=\"userdir\" value=\"$userdir\">\n";
    print HTML "<input type=hidden name=gbfile value=\"$pagename\">\n";
    print HTML "<input type=hidden name=action value=\"add\">\n";
    print HTML "<input type=hidden name=colorset value=\"$colorset\">\n";
    print HTML "<input type=hidden name=gbparms value=\"$gbparms\">\n";
    print HTML "<input type=hidden name=gbhost value=\"$email\">\n";
    print HTML "</form>\n";
    print HTML "<hr>\n";
    }

sub buildpage_bot {
    print HTML "<!--begin-->\n";
    print HTML "<!--end-->\n";
    print HTML "<center><a href=\"mailto:$email\">$usrname</a></font></center>\n";
    print HTML "<center><font size=-1>";
    print HTML "This page was generated by <b>ezguest.$cgi</b> found at ";
    print HTML "<a href=http://www.mannyjuan.com/>manny juan's script page</a></font>\n";
    print HTML "</center>\n";
    print HTML "</body></html>\n";
    close(HTML);
    }

sub save_page_data {
    # Write all of the input into a flat file.
    open(FILE, ">$page_dir$pagename\.dat") || die "I can't create that file >$page_dir$pagename\.dat\n";
    if($win95==0){flock (FILE, 2) or die "can't lock user data file\n";}
    $tbltext =~ s/\n/%%/g;
    print FILE "$usrname&&$email&&$headline&&$content&&$pagename&&$colorset&&$gbparms\n";
    close(FILE);
    chmod 0777, '$page_dir$pagename.dat';
    }

# Standard error message for any missing required fields
sub missing {
    local ($missing) = @_;
    print "content-type: text/html\n\n";

    print "<HTML><head><TITLE>You missed something</TITLE></head>\n";
    print "<body>\n";
    &put_banner;    
    print "You forgot to fill in one of the fields. Please go back and make\n";
    print "sure that all required fields are filled in! $missing\n";
    print "</body></HTML>\n";
    exit;
    }

sub confirm {
    local ($updact) = @_;

    print "content-type: text/html\n\n";
    print "<html><head><title>$updact Confirmation</title></head>\n";
    print "<body bgcolor=\"#ffffff\" TEXT=\"#000000\" link=\"#008000\" vlink=\"#800040\" >\n";
    &put_banner; 
    print "<CENTER><IMG SRC=\"$logo\" alt=\"$logoalt\"  border=0></CENTER>\n";
    print "<P><BR><FONT SIZE=4 FACE=\"COMIC SANS MS,ARIAL\">\n";
    print "<p><h3>Please Enter your login name, e-mail and name of your file to $updact</h3></p>\n";
    print "<form action=\"$cgiurl/ezguest.$cgi\" method=POST>\n";
    print "<input type=hidden name=\"userdir\" value=\"$userdir\">\n";
    print "<P><BR><FONT SIZE=4 FACE=\"COMIC SANS MS,ARIAL\">\n";
    print "Login name:<br>\n";
    print "<input size=40 type=text name=\"login\"><br><br>\n";
    print "E-mail:<br>\n";
    print "<input size=40 type=text name=\"email\"><br><br>\n";
    print "Name of your file:<br>\n";
    print "<input type=text size=40 name=\"pagename\"><br><br>\n";
    print "<input type=submit value=submit>\n";
    print "<input type=hidden name=\"action\" value=\"checkuser\">\n";
    print "<input type=hidden name=\"updact\" value=\"$updact\">\n";
    print "</FONT>\n";
    print "</form></body></html>\n";
    }

sub checkuser {
    open(FILE, "$data") || die "I can't open $data\n";  
    if($win95==0){flock (FILE, 1) or die "can't lock data file\n";}

    while(<FILE>) {
    chop;       
    @all = split(/\n/);

    foreach $line (@all) {
    ($loginname, $loginemail, $loginpagename) = split(/&&/, $line);
    if($loginname eq "$login" && $loginemail eq "$email" && $loginpagename eq "$pagename") {
        $match = 1;
        if($updact eq "edit") {
          &edit($loginpagename);
          }
        else {
          &delpage($loginpagename);
          }
        }
      }
    }

    close(FILE);

    if (! $match) {
        &error;
        }

    # del entry from data
    if($updact eq "delete") {

        # Suck the index page, and write the new entry to it
        open(FILE, "$data") || die "I can't open that file $data\n";
        if($win95==0){flock (FILE, 1) or die "can't lock data file\n";}
            @lines = <FILE>;
            close(FILE);
            $sizelines = @lines;

        # Now, re-open the links file, and comment out the page to delete
        open(FILE, ">$data") || die "I can't open that file >$data\n";
        if($win95==0){flock (FILE,2) or die "can't lock index file for append\n";}
        chop;
                for ($a = 0; $a <= $sizelines; $a++) {
                $_ = $lines[$a];
                $w = $_;
                $w =~ s/\cM//g;
                $w =~ s/\n//g;
        ($loginname, $loginemail, $loginpagename) = split(/&&/, $w);
        if($loginname eq "$login" && $loginemail eq "$email" && $loginpagename eq "$pagename") {
              # do nothing  (ie. don't write)
              } 
            else {
              if($w eq "") {
                # do nothing (skip)
                }
              else {
                print FILE "$w\n";
                }
              }
            }
        close(FILE);
        print "content-type: text/html\n\n";
        print "<html><head><title>$updact Confirmation</title></head>\n";
        print "<body bgcolor=\"#ffffff\" TEXT=\"#000000\" link=\"#008000\" vlink=\"#800040\" >\n";
        &put_banner; 
        print "<CENTER><IMG SRC=\"$logo\" alt=\"$logoalt\" border=0></CENTER>\n";
        print "<P><BR><FONT SIZE=4 FACE=\"COMIC SANS MS,ARIAL\">\n";
        print "<p>your page has been deleted";
        print "<p>(Return to <a href=\"$baseurl\">User Pages</a>)\n";
        print "</form></body></html>\n";
      }
    }

sub edit {

    local ($editfile) = @_;
    
    open(FILE, "$page_dir$editfile\.dat") || die "I can't open $page_dir$editfile\.dat\n";
    if($win95==0){flock (FILE, 1) or die "can't lock data file for edit\n";}

    while(<FILE>) {
    chop;
    @datafile = split(/\n/);

    foreach $line (@datafile) {
        &build_edit_form($line);
            }
         }
    close(FILE);
    }

sub delpage {
    local ($editfile) = @_;
    $cnt=unlink "$page_dir$editfile\.dat", "$page_dir$editfile\.html";

    # Suck the index page, and write the new entry to it
    open(FILE, "$indexpage") || die "I can't open that file $indexpage\n";
    if($win95==0){flock (FILE, 1) or die "can't lock index file\n";}
        @lines = <FILE>;
        close(FILE);
        $sizelines = @lines;

    # Now, re-open the links file, and comment out the page to delete
    open(FILE, ">$indexpage") || die "I can't open that file >$indexpage\n";
    if($win95==0){flock (FILE, 2) or die "can't lock index file to delete entry\n";}

            for ($a = 0; $a <= $sizelines; $a++) {

            $_ = $lines[$a];

        if (/$pagename.html/) {
          # do nothing  (ie. don't write)
          } 
        else {
          print FILE $_;
           }
        }
    close(FILE);

    }

sub build_edit_form {
    local ($line) = @_;
    local($usrname, $email, $headline, $content, $pagename, $colorset, $gbparms );

    ($usrname, $email, $headline, $content, $pagename, $colorset, $gbparms) = split(/&&/, $line);

    ($maxdays,$maxitems,$recipient,$separator,$mail,$linkmail,$remote_mail,
    $line_breaks,$retlink,$usemybkgd,$mybkgdurl,$usemylogo,$mylogourl) = split('~',$gbparms);

    # To avoid any security risks. Take out the HTML tags added when HPM translated
    # the && to: <br><br>. They will be re-translated to: && Once the user updates
    # the page, the: && will be put back to: <br><br>
    $content =~ s/<br><br>/&&/g;

    # print the edit-page form

    print "content-type: text/html\n\n";
    print "<html><head><title>Edit Your Page</title></head>\n";
    print "<body bgcolor=\"#ffffff\" TEXT=\"#000000\" link=\"#008000\" vlink=\"#800040\">\n";
    &put_banner; 
    print "<center><img src=\"$logo\" alt=\"$logoalt\" border=0></center><p>\n";
    print "<table width=75% cellspacing=2 cellpadding=2 border=0>\n";
    print "<tr><td width=100% align=left valign=top>\n";
    print "<p><font face=\"Arial, Geneva\"><h2>Edit Your Page</h2></font></p>\n";
    print "<p>Below is a form with the contents\n";
    print "of the guestbook you created. You can edit any part of your page</p>\n";
    print "<p></p>\n";
    print "<form action=\"$cgiurl/ezguest.$cgi\" method=POST>\n";
    print "<input type=hidden name=\"userdir\" value=\"$userdir\">\n";
    print "<input type=hidden name=\"action\" value=\"recreate\">\n";
    print "Your name:<br>\n";
    print "<input type=text size=40 name=\"usrname\" value=\"$usrname\"><br><br>\n";
    print "Your e-mail:<br>\n";
    print "<input type=text size=40 name=\"email\" value=\"$email\"><br><br>\n";
    print "headline:<br>\n";
    print "<input type=text size=40 name=\"headline\" value=\"$headline\"><br><br>\n";
    print "</td></tr></table>\n";
    print "Name of HTML file: <b>$pagename</b><br><br>\n";
    print "<input type=hidden name=\"pagename\" value=\"$pagename\">\n";
    &build_form_content($usrname, $email, $headline, $content, $pagename, $colorset, $gbparms);
    print "<P><input type=submit value=\"update page\">\n";
    print "</form>\n";

    print "<hr><form action=\"$cgiurl/ezguestd.$cgi\" method=POST>\n";
    print "<p><font face=\"Arial, Geneva\"><h2>Update Guestbook</h2></font></p>\n";
    print "Press this button to delete guestbook entries.\n";
    print "<input type=hidden name=\"userdir\" value=\"$userdir\">\n";
    print "<input type=hidden name=\"pagename\" value=\"$pagename\">\n";
    print "<input type=hidden name=\"action\" value=\"delgbitm\">\n";
    print "<input type=hidden name=\"gbparms\" value=\"$gbparms\">\n";
    print "<input type=hidden name=\"colorset\" value=\"$colorset\">\n";
    print "<P><input type=submit value=\"delete items\">\n";
    print "</form>";

    print "</body></html>\n";
    }

sub build_form_content {
    local ($usrname, $email, $headline, $content, $pagename, $colorset, $gbparms)=@_;

    print "<b>Select Preset Colors:</b>";
    print "<SELECT NAME=\"colorset\">";
    &put_clropt($colorset,'01','FFFFFF~333333~006699~999900');
    &put_clropt($colorset,'02','CCCCCC~000000~0000CC~660066');
    &put_clropt($colorset,'03','FFFF00~FF6600~FF0033~336633');
    &put_clropt($colorset,'04','CCCC66~330000~CC0000~003300');
    &put_clropt($colorset,'05','FFFF99~330000~CC0000~333333');
    &put_clropt($colorset,'06','99CCCC~000066~0000CC~003366');
    &put_clropt($colorset,'07','CC99FF~000000~FF0033~660066');
    &put_clropt($colorset,'08','CCFF99~666600~006699~003300');
    &put_clropt($colorset,'09','FFCC00~330000~CC0000~660066');
    &put_clropt($colorset,'10','00FF33~0000CC~FF0099~660066');
    &put_clropt($colorset,'11','006699~CCFFCC~FFFF00~00FFFF');
    &put_clropt($colorset,'12','330000~FF6666~FFCC00~CCFF99');
    &put_clropt($colorset,'13','003300~CCCC66~FFFFFF~FFFF00');
    &put_clropt($colorset,'14','333333~CCCCCC~FF6666~CCCC66');
    &put_clropt($colorset,'15','666600~FFFFFF~FFFF00~99CCFF');
    &put_clropt($colorset,'16','000000~99CCFF~FFFF00~CCCC66');
    &put_clropt($colorset,'17','333333~FFFFFF~99CCFF~CC99FF');
    &put_clropt($colorset,'18','CC0000~FFFFFF~FFFF00~00FFFF');
    print "\n</SELECT>";
    print "<br><img src=\"$baseurl/ezpalette.gif\"><br><br>\n";
    # print "<b>content:</b><br>\n";
    # print "<textarea cols=70 rows=15 wrap=on name=\"content\">$content</textarea><br><br>\n";
    print "<b>Max Days:</b> maximum days to keep<br>\n";
    print "<input type=text size=5 name=\"maxdays\" value=\"$maxdays\"><br><br>\n";
    print "<b>Max Items:</b> maximum number of guestbook entries<br>\n";
    print "<input type=text size=5 name=\"maxitems\" value=\"$maxitems\"><br><br>\n";
    print "<b>Options:</b>\n";
    print "<table>";
    &prt_ckb($separator, 'separator', 'use a horizontal line to separate entries');
    &prt_ckb($mail, 'mail', 'send an acknowledgment to the guest');
    &prt_ckb($linkmail, 'linkmail', "create a link to the guest\'s email");
    &prt_ckb($remote_mail, 'remote_mail', 'send a notice to me');
    &prt_ckb($line_breaks, 'line_breaks', 'translate line breaks to &lt;br&gt;');
    print "</table>";
    print "<br><b>Return Link (URL):</b>link here when user clicks Return<br>\n";
    print "<input type=text size=50 name=\"retlink\" value=\"$retlink\"><br><br>\n";
    &prt_ckb($usemybkgd, 'usemybkgd', 'use my background image: &nbsp;');
    print "<input type=text size=40 name=\"mybkgdurl\" value=\"$mybkgdurl\"><br><br>\n";
    &prt_ckb($usemylogo, 'usemylogo', 'use my own logo: &nbsp;');
    print "<input type=text size=40 name=\"mylogourl\" value=\"$mylogourl\"><br><br>\n";
    }

sub put_clropt  {
    local ($colorset, $id, $colors)=@_;
    print "\n<OPTION VALUE=\"$colors\"";
    if ($colorset eq $colors) {print " SELECTED";}
    print ">$id";
    }

sub prt_ckb {
    local ($var, $varname, $ckbdesc) = @_;
    print "\n<tr><td><INPUT TYPE=\"CHECKBOX\" NAME=\"$varname\" VALUE=\"1\"";
    if ($var eq "1") {print " CHECKED";} 
    print "></td>";
    print "<td>$ckbdesc</td></tr>";
    }

sub error {
    local ($updact) = @_;
    print "content-type: text/html\n\n";
    print "<html><head><title>Permission Denied</title></head>\n";
    print "<body>\n";
    &put_banner; 
    print "<p><h1>Permission Denied</h1></p>\n";
    print "You do not have permission to $updact\n";
    print "<p>(Return to <a href=\"$baseurl\">User Pages</a>)\n";
    print "</body></html>\n";
    exit;
    }
sub put_banner {
    # do nothing
    }
