#!/usr/bin/perl
require 'date.pl';

# modified by manny juan 1/23/99
# ezguesta.pl was patterned after matt wright's guestbook script and modified so
# it could service multiple guestbooks and support automatic expiration of entries
# by age or file size.
##############################################################################
$SIG{__DIE__} = \&Error_Msg;

sub Error_Msg {
    $msg = "@_";
    print "\nContent-type: text/html\n\n";
    print "The following error occurred : $msg\n";
    exit;
}

# Get the input
read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});

# Split the name-value pairs
@pairs = split(/&/, $buffer);

foreach $pair (@pairs) {
   ($name, $value) = split(/=/, $pair);

   # Un-Webify plus signs and %-encoding
   $value =~ tr/+/ /;
   $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
   $value =~ s/<!--(.|\n)*-->//g;
   $value =~ s/<([^>]|\n)*>//g;
   $FORM{$name} = $value;
}

$userdir=$FORM{'userdir'};
$gbfile=$FORM{'gbfile'};

##############################################################################
# Set Variables HERE

$guestbookurl = "http://www.mannyjuan.com/$userdir/$gbfile.html";
$guestbookreal = "/home/manny/www/$userdir/$gbfile.html";
$imageurl = "http://www.mannyjuan.com/$userdir";
$cgiurl = "/cgi-bin/ezguesta.pl";

# $guestbookurl = "http://127.0.0.1/$userdir/$gbfile.html";
# $guestbookreal = "../webpages/$userdir/$gbfile.html";
# $imageurl = "/$userdir";
# $cgiurl = "/cgi-bin/ezguesta.pl";

# location of date command
$date_command = "/bin/date";

# If you answered 1 to $mail or $remote_mail you will need to fill out 
# these variables below:
$mailprog = '/usr/sbin/sendmail';

# Done
##############################################################################

$gbparms=$FORM{'gbparms'};
($maxdays,$maxitems,$recipient,$separator,$mail,$linkmail,$remote_mail,
$line_breaks,$retlink,$usemybkgd,$mybkgdurl,$usemylogo,$mylogourl) = split('~',$gbparms);

$colorset=$FORM{'colorset'};
if ($colorset eq "") {$colorset='FFFFFF~333333~006699~999900';}
($bkgdc, $textc, $linkc, $vlinkc) = split('~', $colorset);

$logo = "$imageurl/mjmall.jpg";
$logoalt = "Cyber Mall";

# Get the Date for Entry
$date = `$date_command +"%A, %B %d, %Y at %T (%Z)"`; chop($date);
$shortdate = `$date_command +"%D %T %Z"`; chop($shortdate);

if ($FORM{'action'} eq 'add') {
    &new_entry;
    exit;
    }

# Print the Blank Response Subroutines
if ($FORM{'comments'} eq '') {
    &no_comments;
    exit;
    }

if ($FORM{'realname'} eq '') {
    &no_name;
    exit;
    }

# Begin the Editing of the Guestbook File
open (FILE,"$guestbookreal") || die "Can't Open $guestbookreal: $!\n";
@LINES=<FILE>;
close(FILE);
$SIZE=@LINES;

# Open Link File to Output
open (GUEST,">$guestbookreal") || die "Can't Open $guestbookreal: $!\n";

@gtoday=localtime(time);
$today=&today();    

$path=0;
for ($i=0;($i<=$SIZE);$i++) {
   $_=$LINES[$i];
    if ($path==0) {
       if (/<!--begin-->/) { 
          print GUEST "<!--begin-->\n";

          if ($line_breaks == 1) {
             $FORM{'comments'} =~ s/\cM\n/<br>\n/g;
          }

          $d=$gtoday[3];
          $m=$gtoday[4];
          $y=$gtoday[5];
          $m+=1;
          if($y<50) {$y+=2000} else {$y+=1900};
          print GUEST "$m/$d/$y<br>\n";
          print GUEST "<b>$FORM{'comments'}</b><br>\n";

          if ($FORM{'url'}) {
             print GUEST "<a href=\"$FORM{'url'}\">$FORM{'realname'}</a>";
          }
          else {
             print GUEST "$FORM{'realname'}";
          }

          if ( $FORM{'username'} ){
             if ($linkmail eq '1') {
                print GUEST " \&lt;<a href=\"mailto:$FORM{'username'}\">";
                print GUEST "$FORM{'username'}</a>\&gt;";
             }
             else {
                print GUEST " &lt;$FORM{'username'}&gt;";
             }
          }

          print GUEST "<br>\n";

          if ( $FORM{'city'} ){
             print GUEST "$FORM{'city'},";
          }

          if ( $FORM{'state'} ){
             print GUEST " $FORM{'state'}";
          }

          if ( $FORM{'country'} ){
             print GUEST " $FORM{'country'}";
          }

          if ($separator eq '1') {
             print GUEST " - $date<hr>\n\n";
          }
          else {
             print GUEST " - $date<p>\n\n";
          }
          $path=1;
       }
       else {
            print GUEST $_;
            }
        }
    elsif ($path==1) {
        if (/^\d+\/\d+\/\d+/) { 
             ($m, $d, $y) = split(/\//,$_);
             $itemdate = &jday($m, $d, $y);
             if (($today - $itemdate) > $maxdays) {
               $path=2;
               }
             else {
               $items++;
               if($items >= $maxitems) {
                   $path=2;
                   }
               else {
                 print GUEST "$m/$d/$y";
                 }
             }
           }
           else {
              print GUEST $_;
           }
       }
    elsif ($path==2) {
        if (/^<!--end-->/) {
            print GUEST "<!--end-->\n";
            $path=3;
            }
        }
    else {
        print GUEST $_;
        }
   }

close (GUEST);


#########
# Options

# Mail Option
if ($mail eq '1') {
   open (MAIL, "| $mailprog -t") || die "Can't open $mailprog!\n";

   print MAIL "To: $recipient\n";
   print MAIL "Reply-to: $FORM{'username'} ($FORM{'realname'})\n";
   print MAIL "From: $FORM{'username'} ($FORM{'realname'})\n";
   print MAIL "Subject: Entry to Guestbook\n\n";
   print MAIL "You have a new entry in your guestbook:\n\n";
   print MAIL "------------------------------------------------------\n";
   print MAIL "$FORM{'comments'}\n";
   print MAIL "$FORM{'realname'}";

   if ( $FORM{'username'} ){
      print MAIL " <$FORM{'username'}>";
   }

   print MAIL "\n";

   if ( $FORM{'city'} ){
      print MAIL "$FORM{'city'},";
   }

   if ( $FORM{'state'} ){
      print MAIL " $FORM{'state'}";
   }

   if ( $FORM{'country'} ){
      print MAIL " $FORM{'country'}";
   }

   print MAIL " - $date\n";
   print MAIL "------------------------------------------------------\n";

   close (MAIL);
}

if ($remote_mail eq '1' && $FORM{'username'}) {
   open (MAIL, "| $mailprog -t") || die "Can't open $mailprog!\n";

   print MAIL "To: <$FORM{'username'}>\n";
   print MAIL "From: $recipient\n";
   print MAIL "Subject: Entry to Guestbook\n\n";
   print MAIL "Thank you for adding to my guestbook.\n\n";
   print MAIL "------------------------------------------------------\n";
   print MAIL "$FORM{'comments'}\n";
   print MAIL "$FORM{'realname'}";

   if ( $FORM{'username'} ){
      print MAIL " <$FORM{'username'}>";
   }

   print MAIL "\n";

   if ( $FORM{'city'} ){
      print MAIL "$FORM{'city'},";
   }

   if ( $FORM{'state'} ){
      print MAIL " $FORM{'state'}";
   }

   if ( $FORM{'country'} ){
     print MAIL " $FORM{'country'}";
   }

   print MAIL " - $date\n";
   print MAIL "------------------------------------------------------\n";

   close (MAIL);
}

&show_entry;


#######################
# Subroutines

sub new_entry {
    print "Content-type: text/html\n\n";
    print "<html><head><title>New Entry</title></head>\n";
    print "<body ";
    if ($usemybkgd==1) {
        print "background=\"$mybkgdurl\"&nbsp";
        }
    print "bgcolor=\"#$bkgdc\" TEXT=\"#$textc\" link=\"#$linkc\" vlink=\"#$vlinkc\">\n";
#   print "\n<!--banner code here-->";
    print "<center><img src=\"";
    if ($usemylogo==1) {
        print "$mylogourl";
        }
    else {
        print "$logo";
        }
    print "\"></center>";
    print "<h1>Add To Our Guestbook</h1>\n";
    print "Fill in the blanks below to add to our guestbook.";
    print "The only blanks that you have to fill in are the comments and name section. Thanks!\n";
    print "<form method=POST action=\"$cgiurl\">\n";
    &get_fields;
    print "\n</form>";
    print "\n</body></html>\n";
}

sub no_comments {
    print "Content-type: text/html\n\n";
    print "<html><head><title>No Comments</title></head>\n";
    print "<body><h1>Your Comments appear to be blank</h1>\n";
    print "The comment section in the guestbook fillout form appears\n";
    print "to be blank and therefore the Guestbook Addition was not\n";
    print "added.  Please enter your comments below.<p>\n";
    print "<form method=POST action=\"$cgiurl\">\n";
    &get_fields;
    print "\n</form>";
    print "\n</body></html>\n";
}

sub no_name {
    print "Content-type: text/html\n\n";
    print "<html><head><title>No Name</title></head>\n";
    print "<body><h1>Your Name appears to be blank</h1>\n";
    print "The Name Section in the guestbook fillout form appears to\n";
    print "be blank and therefore your entry to the guestbook was not\n";
    print "added.  Please add your name in the blank below.<p>\n";
    print "<form method=POST action=\"$cgiurl\">\n";
    &get_fields;
    print "\n</form>";
    print "\n</body></html>\n";
}

sub get_fields {
    print "Your Name:<input type=text name=\"realname\" size=30 ";
    print "value=\"$FORM{'realname'}\"><br>\n";
    print "E-Mail: <input type=text name=\"username\""; 
    print "value=\"$FORM{'username'}\" size=40><br>\n";
    print "URL: <input type=text name=\"url\""; 
    print "value=\"$FORM{'url'}\" size=50><br>\n";
    print "City: <input type=text name=\"city\" value=\"$FORM{'city'}\" ";
    print "size=15>, State: <input type=text name=\"state\" "; 
    print "value=\"$FORM{'state'}\" size=15> Country: <input type=text "; 
    print "name=\"country\" value=\"$FORM{'country'}\" size=15><p>\n";
    print "Comments:<br>\n";
    print "<textarea name=\"comments\" COLS=60 ROWS=4></textarea><p>\n";
    print "<input type=submit> * <input type=reset><hr>\n";
    print "<input type=hidden name=\"userdir\" value=\"$userdir\">";
    print "<input type=hidden name=\"gbfile\" value=\"$gbfile\">";
    print "<input type=hidden name=\"gbparms\" value=\"";
    print "$maxdays~$maxitems~$recipient~$separator~$mail~$linkmail~$remote_mail~$line_breaks~$retlink~$usemybkgd~$mybkgdurl~$usemylogo~$mylogourl";
    print "\">";
    print "<input type=hidden name=\"colorset\" value=\"$colorset\">";
    print "\nReturn to the <a href=\"$guestbookurl\">Guestbook</a>.";
    }


sub show_entry {

   # Print Beginning of HTML
   print "Content-Type: text/html\n\n";
   print "<html><head><title>Thank You</title></head>\n";
    print "<body ";
    if ($usemybkgd==1) {
        print "background=\"$mybkgdurl\"&nbsp";
        }
    print "bgcolor=\"#$bkgdc\" TEXT=\"#$textc\" link=\"#$linkc\" vlink=\"#$vlinkc\">\n";
#   print "\n<!--banner code here-->";
    print "<center><img src=\"";
    if ($usemylogo==1) {
        print "$mylogourl";
        }
    else {
        print "$logo";
        }
    print "\"></center>";
    print "<h1>Thank You For Signing The Guestbook</h1>\n";

   # Print Response
   print "Thank you for filling in the guestbook.  Your entry has\n";
   print "been added to the guestbook.<hr>\n";
   print "Here is what you submitted:<p>\n";
   print "<b>$FORM{'comments'}</b><br>\n";

   if ($FORM{'url'}) {
      print "<a href=\"$FORM{'url'}\">$FORM{'realname'}</a>";
   }
   else {
      print "$FORM{'realname'}";
   }

   if ( $FORM{'username'} ){
      if ($linkmail eq '1') {
         print " &lt;<a href=\"mailto:$FORM{'username'}\">";
         print "$FORM{'username'}</a>&gt;";
      }
      else {
         print " &lt;$FORM{'username'}&gt;";
      }
   }

   print "<br>\n";

   if ( $FORM{'city'} ){
      print "$FORM{'city'},";
   }

   if ( $FORM{'state'} ){
      print " $FORM{'state'}";
   }

   if ( $FORM{'country'} ){
      print " $FORM{'country'}";
   }

   print " - $date<p>\n";

   # Print End of HTML
   print "<hr>\n";
   print "<a href=\"$guestbookurl\">Back to the Guestbook</a>\n"; 
   print "- You may need to RELOAD it when you get there to see your\n";
   print "entry.\n";
   print "</body></html>\n";

   exit;
}

